;============================================================
;STRUCTURES
;============================================================

struct atxdrv_inst_data 	;should be DWORD aligned, no negative values
    VTable	       dd      ?
    Ref 	       dd      ?
    Instance	       dd      ?
    TempInstance       dd      ?
    GravityPush        dd      ?
    KeyHandlerTick     dd      ?
    MvtHandlerTick     dd      ?
    RotPosOffset       dd      ?       ;rotation position offset (1D, offsets effect of rotation)
    FrontFastAccel     dd      ?       ;floats/s^2 (acceleration)
    FrontSlowAccel     dd      ?
    BackSlowAccel      dd      ?
    BackBrakeDecel     dd      ?       ;used when velocity > 0
    NaturalDecel       dd      ?       ;used when no mvt keys pressed
    RotationAccelL     dd      ?       ;should be positive - rotation acceleration (left and right) (radian angles/S^2)
    RotationAccelR     dd      ?       ;should be negative
    RotationDecel      dd      ?       ;used when no rotation keys pressed (should be high)
    MaxFastVelocity    dd      ?
    MaxSlowVelocity    dd      ?       ;approximate
    MaxBackVelocity    dd      ?       ;CONVERT FROM POSITIVE TO NEGATIVE
    MaxTurnVelocityL   dd      ?
    MaxTurnVelocityR   dd      ?       ;CONVERT FROM POSITIVE TO NEGATIVE
    MinVelocityForTurn dd      ?
ends

struct jump_info				;20 BYTES
    Push	       dd      ?
    JumpAngle	       dd      ?
    JumpTendancy       dd      ?
    RepeatPeriod       dd      ?
    LastTickCount      dd      ?
ends

struct CAPTUREPARMS		;size = 96
    dwRequestMicroSecPerFrame	       dd      ?
    fMakeUserHitOKToCapture	       dd      ?
    wPercentDropForError	       dd      ?
    fYield			       dd      ?
    dwIndexSize 		       dd      ?
    wChunkGranularity		       dd      ?
    fUsingDOSMemory		       dd      ?
    wNumVideoRequested		       dd      ?
    fCaptureAudio		       dd      ?
    wNumAudioRequested		       dd      ?
    vKeyAbort			       dd      ?
    fAbortLeftMouse		       dd      ?
    fAbortRightMouse		       dd      ?
    fLimitEnabled		       dd      ?
    wTimeLimit			       dd      ?
    fMCIControl 		       dd      ?
    fStepMCIDevice		       dd      ?
    dwMCIStartTime		       dd      ?
    dwMCIStopTime		       dd      ?
    fStepCaptureAt2x		       dd      ?
    wStepCaptureAverageFrames	       dd      ?
    dwAudioBufferSize		       dd      ?
    fDisableWriteCache		       dd      ?
    AVStreamMaster		       dd      ?
ends

struct AVISTREAMINFO
    fccType			       dd      ?
    fccHandler			       dd      ?
    dwFlags			       dd      ?
    dwCaps			       dd      ?
    wPriority			       dw      ?
    wLanguage			       dw      ?
    dwScale			       dd      ?
    dwRate			       dd      ?
    dwStart			       dd      ?
    dwLength			       dd      ?
    dwInitialFrames		       dd      ?
    dwSuggestedBufferSize	       dd      ?
    dwQuality			       dd      ?
    dwSampleSize		       dd      ?
    rcFrame			       RECT
    dwEditCount 		       dd      ?
    dwFormatChangeCount 	       dd      ?
    szName			       db      64 dup ?
ends

struct AVICOMPRESSOPTIONS
    fccType			       dd      ?
    fccHandler			       dd      ?
    dwKeyFrameEvery		       dd      ?
    dwQuality			       dd      ?
    dwBytesPerSecond		       dd      ?
    dwFlags			       dd      ?
    lpFormat			       dd      ?
    cbFormat			       dd      ?
    lpParms			       dd      ?
    cbParms			       dd      ?
    dwInterleaveEvery		       dd      ?
ends

struct DIBDUMPHEADER
    AtxDIBId			       db      'ATXR'	   ;if included in final file, save was successful
    SaveFlags			       dd      ?
    HeaderSize			       dd      sizeof.DIBDUMPHEADER
    BitmapData			       BITMAPINFOHEADER 	sizeof.BITMAPINFOHEADER
    Framerate			       dd      ?
    FrameRepeatTableFileOffset	       dd      ?
    FrameRepeatTableFileOffsetHigh     dd      ?
    DiffFrameCount		       dd      ?	  ;excludes frame repetitions (new frames only)
    TrueFrameCount		       dd      ?	  ;includes repetitions
    MaxFrameCount		       dd      ?
    FrameRepCount		       dd      ?
    rv_rt_error_count		       dd      ?
ends

