;========================================================
ATXDRV_MAIN_RT_PROC:
;========================================================
StraightEmitterTargetDistance_ATXDRV	    equ     [float_100]

cmp [IsInGame_BOOL],0
     jz NoATXDRV_MAIN_RT_PROC
cmp [IsInConsole_BOOL],1
     jz NoATXDRV_MAIN_RT_PROC

      invoke GetTickCount
      mov esi,eax

;key handler (acceleration handler)
      sub eax,[ATXDRV_KeyLastTick]
      cmp eax,[ATXDRV_CURRENT.KeyHandlerTick]
	  jb NoATXDRVKeyHandlerProc
      push eax
      add [ATXDRV_KeyLastTick],eax
      fild DWORD [esp]
      fmul [float_0_001]
      add esp,4
      fstp [ATXDRV_KeyTime]
	  call ATXDRV_KEYHANDLER
 NoATXDRVKeyHandlerProc:

;mvt/animation coordinator (velocity handler)
      sub esi,[ATXDRV_MvtLastTick]
      cmp esi,[ATXDRV_CURRENT.MvtHandlerTick]
	  jb NoATXDRVMvtHandlerProc
      push esi
      add [ATXDRV_MvtLastTick],esi
      fild DWORD [esp]
      fmul [float_0_001]
      add esp,4
      fstp [ATXDRV_MvtTime]
	  call ATXDRV_MVTHANDLER
 NoATXDRVMvtHandlerProc:

NoATXDRV_MAIN_RT_PROC:
ret

;========================================================
ATXDRV_KEYHANDLER:	  ;handles acceleration
;========================================================
;-> only accepts one mvt key and one rotation key per call (not as damaging
;   to framerate as may seem)

      mov edi,[KEY_LIST_ADDR]
      mov [ATXDRV_KeyPressed],FALSE

;forward fast key
      invoke GetAsyncKeyState,[edi+80]
      test eax,80000000h
	   jz DRV_NoForwardFastKeyPress
	   or [ATXDRV_KeyPressed],1
	   fld [ATXDRV_CurrVelocity]
	   fld [ATXDRV_CURRENT.FrontFastAccel]
	   fmul [ATXDRV_KeyTime]	   ;find velocity difference
	   faddp st1,st0		;add to velocity
	   fst [ATXDRV_CurrVelocity]
	   fcomp [ATXDRV_CURRENT.MaxFastVelocity]
	   mov ecx,[ATXDRV_CURRENT.MaxFastVelocity]
	   fstsw ax
	   test eax,100h	    ;has velocity gone over set limit?
		jnz DRV_NoBackwardKeyPress
	   mov [ATXDRV_CurrVelocity],ecx
	   jmp DRV_NoBackwardKeyPress
      DRV_NoForwardFastKeyPress:

;forward slow key
      invoke GetAsyncKeyState,[edi+88]
      test eax,80000000h
	   jz DRV_NoForwardSlowKeyPress
	   or [ATXDRV_KeyPressed],1
	   fld [ATXDRV_CurrVelocity]
	   fcomp [ATXDRV_CURRENT.MaxSlowVelocity]
	   fstsw ax
	   test eax,100h	       ;below max slow velocity?
		jz DRV_NoBackwardKeyPress
	   fld [ATXDRV_CURRENT.FrontSlowAccel]
	   fmul [ATXDRV_KeyTime]
	   fadd [ATXDRV_CurrVelocity]
	   fstp [ATXDRV_CurrVelocity]
	   jmp DRV_NoBackwardKeyPress
      DRV_NoForwardSlowKeyPress:

;backward key
      invoke GetAsyncKeyState,[edi+96]
      test eax,80000000h
	   jz DRV_NoBackwardKeyPress
	   or [ATXDRV_KeyPressed],1
	   fld [ATXDRV_CurrVelocity]
	   fcom [float_0]
	   fstsw ax
	   test eax,4500h
		jnz DRV_BackwardKeyNoBrake
		fld [ATXDRV_CURRENT.BackBrakeDecel]	;velocity above zero (velocity in st0)
		fmul [ATXDRV_KeyTime]
		fsubp st1,st0
		fst [ATXDRV_CurrVelocity]
		fcomp [float_0]
		xor ecx,ecx
		fstsw ax
		test eax,100h
		     jz DRV_NoBackwardKeyPress
		     mov [ATXDRV_CurrVelocity],ecx
		jmp DRV_NoBackwardKeyPress
	   DRV_BackwardKeyNoBrake:	   ;velocity null or below (velocity in st0)
		fld [ATXDRV_CURRENT.BackSlowAccel]
		fmul [ATXDRV_KeyTime]
		fsubp st1,st0
		fst [ATXDRV_CurrVelocity]
		fcomp [ATXDRV_CURRENT.MaxBackVelocity]
		mov ecx,[ATXDRV_CURRENT.MaxBackVelocity]
		fstsw ax
		test eax,100h
		     jz DRV_NoBackwardKeyPress
		mov [ATXDRV_CurrVelocity],ecx
      DRV_NoBackwardKeyPress:

;turn left key (positive angles)
      invoke GetAsyncKeyState,[edi+104]
      test eax,80000000h
	   jz DRV_NoSideLeftKeyPress
	   or [ATXDRV_KeyPressed],2
	   fld [ATXDRV_CURRENT.RotationAccelL]
	   fmul [ATXDRV_KeyTime]
	   fadd [ATXDRV_CurrRotSpeed]
	   fst [ATXDRV_CurrRotSpeed]
	   fcomp [ATXDRV_CURRENT.MaxTurnVelocityL]
	   mov ecx,[ATXDRV_CURRENT.MaxTurnVelocityL]
	   fstsw ax
	   test eax,4500h
		jnz DRV_NoSideRightKeyPress	 ;skip turn right key if left pressed
		mov [ATXDRV_CurrRotSpeed],ecx
	   jmp DRV_NoSideRightKeyPress
      DRV_NoSideLeftKeyPress :

;turn right key (negative angles)
      invoke GetAsyncKeyState,[edi+112]
      test eax,80000000h
	   jz DRV_NoSideRightKeyPress
	   or [ATXDRV_KeyPressed],2
	   fld [ATXDRV_CURRENT.RotationAccelR]
	   fmul [ATXDRV_KeyTime]
	   fsubr [ATXDRV_CurrRotSpeed]
	   fst [ATXDRV_CurrRotSpeed]
	   fcomp [ATXDRV_CURRENT.MaxTurnVelocityR]
	   mov ecx,[ATXDRV_CURRENT.MaxTurnVelocityR]
	   fstsw ax
	   test eax,100h
		jz DRV_NoSideRightKeyPress
		mov [ATXDRV_CurrRotSpeed],ecx
      DRV_NoSideRightKeyPress:

;natural speed diminish (mvt keys)
      test [ATXDRV_KeyPressed],1
	   jnz DRV_NoSpeedDiminish
	   fld [ATXDRV_CURRENT.NaturalDecel]
	   fmul [ATXDRV_KeyTime]
	   fld [ATXDRV_CurrVelocity]
	   fcom [float_0]
	   fstsw ax
	   test eax,4000h	  ;speed null?
		jz DRV_DoSpeedDiminish
		fstp st0
		fstp st0
		jmp DRV_NoSpeedDiminish
	   DRV_DoSpeedDiminish:
	   test eax,100h		     ;below 0?
		jnz DRV_SpeedDiminishPositive
		fsubrp st1,st0		;CurrVelocity - NaturalDecel
		fst [ATXDRV_CurrVelocity]
		fcomp [float_0]
		xor ecx,ecx
		fstsw ax
		test eax,100h		;must not go below 0
		     jz DRV_NoSpeedDiminish
		     mov [ATXDRV_CurrVelocity],ecx
		jmp DRV_NoSpeedDiminish
	   DRV_SpeedDiminishPositive:
		faddp st1,st0		;CurrVelocity + NaturalDecel
		fst [ATXDRV_CurrVelocity]
		fcomp [float_0]
		xor ecx,ecx
		fstsw ax
		test eax,4500h		;must not go over 0
		     jnz DRV_NoSpeedDiminish
		     mov [ATXDRV_CurrVelocity],ecx
      DRV_NoSpeedDiminish:

;natural rotation diminish (rot keys)
      test [ATXDRV_KeyPressed],2
	   jnz DRV_NoROTDiminish
	   fld [ATXDRV_CURRENT.RotationDecel]
	   fmul [ATXDRV_KeyTime]
	   fld [ATXDRV_CurrRotSpeed]
	   fcom [float_0]
	   fstsw ax
	   test eax,4000h
		jz DRV_DoROTDiminish
		fstp st0
		fstp st0
		jmp DRV_NoROTDiminish
	   DRV_DoROTDiminish:
	   test eax,100h
		jnz DVR_ROTDiminishPositive
		fsubrp st1,st0		;CurrRotSpeed - RotationDecel
		fst [ATXDRV_CurrRotSpeed]
		fcomp [float_0]
		xor ecx,ecx
		fstsw ax
		test eax,100h		;must not go below 0
		     jz DRV_NoROTDiminish
		     mov [ATXDRV_CurrRotSpeed],ecx
		jmp DRV_NoROTDiminish
	   DVR_ROTDiminishPositive:
		faddp st1,st0		;CurrRotSpeed + RotationDecel
		fst [ATXDRV_CurrRotSpeed]
		fcomp [float_0]
		xor ecx,ecx
		fstsw ax
		test eax,4500h		;must not go over 0
		     jnz DRV_NoROTDiminish
		     mov [ATXDRV_CurrRotSpeed],ecx
      DRV_NoROTDiminish:

ret

;========================================================
ATXDRV_MVTHANDLER:	   ;handles velocity and displacement
;========================================================
      call ATXDRV_SET_SAVE_OBJ_POS_ROT

;Forward/backward movement
      fld [ATXDRV_CurrVelocity]
      fcom [float_0]
      fstsw ax
      test eax,4000h
	   jnz NO_ATXDRV_MVTHANDLER	;if velocity null, do not apply any changes (no rotation or other)
      fmul [ATXDRV_MvtTime]		;displacement (= velocity * time)
      sub esp,4
      fstp DWORD [esp]
      call ATXDRV_STRAIGHT_PROC 	;do straight mvt

;Left/Right rotation
      fld [ATXDRV_CurrVelocity]
      fabs
      fcomp [ATXDRV_CURRENT.MinVelocityForTurn]
      fstsw ax
      test eax,100h
	   jnz DRV_NO_OBJECT_ROTATION1
      fld [ATXDRV_CurrRotSpeed]
      fmul [ATXDRV_MvtTime]		;total angle rotation (= (radians/sec) * time)
      sub esp,4
      fstp DWORD [esp]
      call ATXDRV_SIDE_PROC		;do object rotation
      DRV_NO_OBJECT_ROTATION1:

;Extra physics, new instance position/rot. set, AT10 physics un-freeze, update player position
      mov ebx,[ATXDRV_CURRENT.Instance]
      call ATXDRV_SETNEWROTPOS
      ;call ATXDRV_APPLYPUSH
      call ATXDRV_UPDATE_PLAYERPOS

ret

NO_ATXDRV_MVTHANDLER:
      fstp st0
ret


;========================================================
ATXDRV_SET_SAVE_OBJ_POS_ROT:
;========================================================
	push esi
	push edi
	mov edx,[ATXDRV_CURRENT.Instance]
	mov edi,ATXDRV_INITIALROTPOS
	lea esi,[edx+30h]
	mov ecx,7
	rep movsd

	lea esi,[edx+30h]
	mov edi,AT18_SIM_OBJECT+0Ch
	mov ecx,7
	rep movsd
	pop edi
	pop esi
ret

;========================================================
ATXDRV_STRAIGHT_PROC:	;[esp+4] = forward vector
;========================================================
push ebx
	mov ebx,AT18_SIM_OBJECT+0Ch
	push 0
	lea ecx,[ebx+0Ch]
	push Temp_Fly_Buffer2
	call CONVERT_TO_FACING_PROC_010

	mov ecx,ebx
	push DWORD [esp+8]			;vector length
	mov edx,ebx
	call FacingToVectorAdd			;eax = facing values

pop ebx
ret 4

;========================================================
ATXDRV_SIDE_PROC:   ;[esp+4] = rotation angle
;========================================================
;This proc is VERY far from optimal, so it does not use matrices for
;rotation or anything deviant from what has been used in ATX so far (quat mul., facing values).
;Remember, I'm not a 3D programmer, so bear with me.
;What it does:
;Rotates the current instance by a certain angle, around a certain point (on the x-y plane ONLY,
;this plane being relative to the object's current facing values and NOT to the fixed world x-y plane).
;Normally, the game rotates objects around their centers (without location
;modification), so the only way I can emulate rotating around a specifiable
;point (with my knowledge) is to use a series of quat rotations and vector additions.
;Note: The new rotation point can only be shifted along the axis defined by the object's
;original facing values, so it is relatively one-dimensional.
;1. Substract the specified offset from the object's position to get the new point of rotation.
;   (with relative X-Y plane). This is done by using the object's initial facing values to
;   create a vector to substract along the object's current facing value (single-axis only).
;   The rotation point offset defines the length of this vector.
;2. Do rotation of object using quat multiplication.
;3. Use the new rotation values to create a vector (with length defined by rotation point offset)
;   to add to the point of rotation (which gives final location). (note: must make sure to negate vector
;   for main function, or it will substract instread of adding).

push ebp
mov ebp,esp
sub esp,16+16
push ebx

	mov ebx,AT18_SIM_OBJECT+0Ch

;move object position to point determined by offset
	push Temp_Fly_Buffer3			;(default/no importance here)
	lea ecx,[ebx+0Ch]			;source values (quat)
	push Temp_Fly_Buffer2			;param 1 = dest for values (returned in eax)
	call CONVERT_TO_FACING_PROC_010 	;2 params

	mov ecx,ebx
	push [ATXDRV_CURRENT.RotPosOffset]	;vector length (offset)
	mov edx,ebx
	call FacingToVectorAdd			;eax = facing values

;rotation object around object's relative z axis (not world z axis)
	lea ecx,[ebp+8]
	lea edx,[ebp-16]
	call ToLocalQuat_AxisZ

	lea eax,[ebx+0Ch]		    ;instance quat
	lea ecx,[ebp-16]		    ;local rotation
	lea edx,[ebp-32]		    ;new quat
	call QuaternionMul

	mov eax,[ebp-32]
	mov [ebx+0Ch],eax
	mov eax,[ebp-28]
	mov [ebx+10h],eax
	mov eax,[ebp-24]
	mov [ebx+14h],eax
	mov eax,[ebp-20]
	mov [ebx+18h],eax

;move object position in new facing direction (to finally emulate rotation around new point)
	push 0					;(default/no importance here)
	mov ecx,AT18_SIM_OBJECT+0Ch+0Ch        ;source values (new quat)
	push Temp_Fly_Buffer2			;param 1 = dest for values (returned in eax)
	call CONVERT_TO_FACING_PROC_010 	;2 params

	mov ecx,ebx
	push [ATXDRV_CURRENT.RotPosOffset]	;vector length (offset)
	mov edx,ebx
	call FacingToVectorSub			;eax = facing values

pop ebx
mov esp,ebp
pop ebp
ret 4

;========================================================
ATXDRV_SETNEWROTPOS:	     ;(of target instance)
;========================================================
;ebx = instance
;AT18_SIM_OBJECT+0Ch has position data
	mov eax,[ATXDRV_CURRENT.TempInstance]
	mov ecx,AT18_SIM_OBJECT
	mov [ecx+08],eax
	mov DWORD [ecx+04],0
	mov eax,[ecx]
	mov DWORD [ecx+28h],01010101h	 ;all 4 booleans set to TRUE
	call DWORD [eax+8h]
ret

;========================================================
ATXDRV_APPLYPUSH:
;========================================================
;ebx = instance
;-> used to tell engine to start physics on object once more; damaging
;   to framerate, but if not used, will cause collision detection issues

	fld DWORD [ebx+38h]
	mov edx,AT10_EMITTER_SIM_OBJECT
	fadd [float_100]
	mov eax,[ebx+30h]
	mov [edx+30h],eax
	mov eax,[ebx+34h]
	mov [edx+34h],eax
	mov eax,[ebx+4Ch]
	mov [edx+4Ch],eax
	fstp DWORD [edx+38h]

	mov eax,[ATXDRV_CURRENT.GravityPush]
	mov ecx,AT10_SIM_OBJECT
	mov DWORD [ecx+38h],eax 		;Push

	xor eax,eax
	mov [ecx+18h],ebx			;Target
	mov [ecx+04h],eax

	mov DWORD [edx+4],eax
	mov DWORD [edx+3Ch],0.70710678118654752440084436210485
	mov DWORD [edx+40h],-0.70710678118654752440084436210485
	mov DWORD [edx+44h],eax
	mov DWORD [edx+48h],eax

	mov DWORD [ecx+3Ch],eax 		;Emitter object
	and BYTE [ecx+1Ch],0			;Impulse

	mov [ecx+14h],al			;Frozen bool
	mov [ecx+08h],eax			;X velocity
	mov [ecx+0Ch],eax			;Y velocity
	mov [ecx+10h],eax			;Z velocity
	mov [ecx+2Ch],eax			;X facing value (???)
	mov [ecx+34h],eax			;Z facing value (???)
	mov eax,[ecx]
	mov [ecx+30h],DWORD 1.000000		;Y facing value (???)
	call DWORD [eax+8]			;AT10 MAIN PROC

ret

;========================================================
ATXDRV_UPDATE_PLAYERPOS:     ;if player position not updated, will not follow object
;========================================================
;ebx = instance
;must use new values directly from object

ret

;========================================================



