;===============================================================
;KEY INTERCEPTION/HANDLING
;===============================================================
;NOTE: For all general movement keys, the game DOES NOT process
;the WM_KEYDOWN, WM_KEYUP, or WM_CHAR messages.
;
;-> General movement keys are scanned using a call to GetAsyncKeyState,
; referenced nearest to the end of the executable (005DBCE2 for
; P6 1.1 exe).
;-> Console/command-line (i.e., saving) keys are processed from
; the WM_CHAR message.
;-> General system keys (ESC, PrintScreen, F11, etc.) are scanned
; from the WM_KEYDOWN message.
;===============================================================
MACRO TESTKEY sourcekey,destjump {
    local NoKey
    cmp sourcekey,0
	jz NoKey
    cmp eax,sourcekey
	jz destjump
    NoKey:
	}

;===============================================================
;WM_CHAR HANDLER
;===============================================================
MAIN_KEYHANDLER:	;WNDPROC params start at [esp+10h]
movsx edx,WORD [esp+1Ch]	;replaced code
mov eax,[esp+18h]		;replaced code (eax=wparam=char)
push eax
push ecx
push edx

cmp [IsInGame_BOOL],0
     jz MAIN_KEYHANDLER_EXIT
	TESTKEY [UseToggleNewKeys],ToggleNewKeys_359324
	cmp [ToggleNewKeys_BOOL],0
	    jz NoNewKeys_43554

cmp [IsInConsole_BOOL],1
     jz MAIN_KEYHANDLER_EXIT

	TESTKEY [UseUserMapKey],ToggleMap_43545
	TESTKEY [UseUserMDinoKey],ToggleMDinos_4324
	TESTKEY [UseDrawDistSubKey],SubstractFromDrawDist_343
	TESTKEY [UseDrawDistAddKey],AddToDrawDist_343
	TESTKEY [UseCANIMALKey],ShowCANIMALCHEAT_3443
	TESTKEY [UseUserMSelKey],ShowMSELCHEAT_3443
	TESTKEY [UseUserCANIMALLEFTKey],CANIMAL_LEFT_3443
	TESTKEY [UseUserCANIMALRIGHTKey],CANIMAL_RIGHT_3443
	TESTKEY [UseATXDRVEscKey],ExitATXDRVMode_32434

;------------------------------ TEMP CODE
;xor edx,edx
;mov dl,'m'
;TESTKEY edx,add_temp_offset
;mov dl,'n'
;TESTKEY edx,sub_temp_offset
;------------------------------ END TEMP CODE

NoNewKeys_43554:

MAIN_KEYHANDLER_EXIT:
pop edx
pop ecx
pop eax
ret

;------------------------------ TEMP CODE
;add_temp_offset:
;add [Test_Var_MISC],4
;jmp EXITKEYHANDLER_PASSIVE

;sub_temp_offset:
;sub [Test_Var_MISC],4
;jmp EXITKEYHANDLER_PASSIVE
;------------------------------ END TEMP CODE


;===============================================================
ToggleNewKeys_359324:
	xor [ToggleNewKeys_BOOL],1
	invoke GetTickCount
	mov [ToggleKeysShowStateTime],eax
	;...
;===============================================================
EXITKEYHANDLER:
	pop edx
	pop ecx
	pop eax
	add esp,4		;get rid of return address
	pop edi
	xor eax,eax
	pop esi
	ret 10h

EXITKEYHANDLER_PASSIVE:
	pop edx
	pop ecx
	pop eax
	ret
;===============================================================
ToggleMap_43545:
	xor [USE_MAP],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ToggleMDinos_4324:
	xor [ShowDinosOnMap_BOOL],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
SubstractFromDrawDist_343:
	push DWORD -1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
AddToDrawDist_343:
	push DWORD 1.000000
	call ModifyDrawDistanceRT
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ShowCANIMALCHEAT_3443:
	xor [DisplayDinoInfo_BOOL],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ShowMSELCHEAT_3443:
	xor [ShowActiveDinoOnMap_BOOL],1
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
CANIMAL_LEFT_3443:
	call CYCLEDINOINFOLEFT_PROC
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
CANIMAL_RIGHT_3443:
	call CYCLEDINOINFORIGHT_PROC
jmp EXITKEYHANDLER_PASSIVE
;===============================================================
ExitATXDRVMode_32434:
	call AT108MAIN
jmp EXITKEYHANDLER_PASSIVE

;===============================================================
;WM_KEYDOWN HANDLER
;===============================================================
;this code is used to disable certain keys' disabling and to
;test if we are in-game, in menu, at console, etc.

KEYDOWNHANDLERPROC:
mov eax,[esp+1Ch]	;REPLACED CODE
mov edx,[esp+18h]

	cmp edx,VK_ESCAPE
	    jz Keydown_ESC_Press
	cmp edx,VK_F1
	    jz Keydown_F1_Press
	cmp edx,VK_F11
	    jz Keydown_F11_Press

mov edx,eax		;REPLACED CODE
ret

;===============================================================
Keydown_ESC_Press:
	and [IsInConsole_BOOL],0
	and [IsInGame_BOOL],0
mov edx,eax		;REPLACED CODE
ret
;===============================================================
Keydown_F1_Press:
	and [IsInGame_BOOL],0
mov edx,eax		;REPLACED CODE
ret
;===============================================================
Keydown_F11_Press:
	and [IsInConsole_BOOL],0
mov edx,eax		;REPLACED CODE
ret
;===============================================================
CONSOLE_OPEN_KEYS_PRESSED:	;if CTRL is pressed,
cmp [IsInGame_BOOL],0		;usually follows Keydown_F11_Press
    jz NO_CONSOLE_OPEN_KEYS_PRESSED
xor [IsInConsole_BOOL],1
NO_CONSOLE_OPEN_KEYS_PRESSED:

mov ecx,[esi+38h]	 ;REPLACED CODE
mov eax,[ecx]		 ;REPLACED CODE
call DWORD [eax+28h]	 ;REPLACED CODE
ret
;===============================================================