;========================================================
ATXDRV_MAIN_RT_PROC:
;========================================================
StraightEmitterTargetDistance_ATXDRV	    equ     [float_100]

cmp [IsInGame_BOOL],0
     jz NoATXDRV_MAIN_RT_PROC
cmp [IsInConsole_BOOL],1
     jz NoATXDRV_MAIN_RT_PROC

;Key Handler
      call ATXDRV_KEYHANDLERPROC

;straight movement
      fld [ATXDRV_CURRENT.StraightSpeed]
      fstp DWORD [esp-4]
      mov eax,[IntrCurrStraight]
      cmp eax,MaxStraightTimeInterval_ATXDRV	   ;test range around this value,
	  jb DoPositiveMvt			   ;if within, do nothing
	  cmp eax,MaxStraightTimeInterval_ATXDRV+ATXDRV_Brake_Interval
	      jb ATXDRV_MvtDone 		   ;stopped?
	  sub eax,MaxStraightTimeInterval_ATXDRV*2
	  neg eax
	  fld DWORD [esp-4]
	  fchs
	  fstp DWORD [esp-4]
      DoPositiveMvt:

      mov edx,esi
      sub edx,[LTCStraight]
      cmp edx,eax
	  jb ATXDRV_MvtDone
      add [LTCStraight],eax

		sub esp,4      ;for ATXDRV_STRAIGHT_PROC
		call ATXDRV_SET_SAVE_OBJ_POS_ROT
		call ATXDRV_STRAIGHT_PROC

;left/right rotation (if no straight movement, automatically no rotation)
      fld [ATXDRV_CURRENT.RotAngle]
      fstp DWORD [esp-4]
      mov eax,[IntrCurrSide]
      cmp eax,0
	  jl ATXDRV_UseSideMvtLeft
	  cmp eax,ATXDRV_NoRot_Interval
	      jb ATXDRV_SideMvtDone
	  sub eax,MaxSideTimeInterval_ATXDRV
	  neg eax
	  fld DWORD [esp-4]
	  fchs
	  fstp DWORD [esp-4]
	  jmp ATXDRV_UseSideMvtRight
      ATXDRV_UseSideMvtLeft:
      cmp eax,-ATXDRV_NoRot_Interval
	  jg ATXDRV_SideMvtDone
      add eax,MaxSideTimeInterval_ATXDRV
      ATXDRV_UseSideMvtRight:

      mov edx,esi
      sub edx,[LTCSide]
      cmp edx,eax
	  jb ATXDRV_SideMvtDone
      add [LTCSide],eax

		sub esp,4
		call ATXDRV_SIDE_PROC
      ATXDRV_SideMvtDone:
		mov ebx,[ATXDRV_CURRENT.Instance]
		call ATXDRV_APPLYPHYSICS
		call ATXDRV_SETNEWROTPOS
		call ATXDRV_APPLYPUSH
		call ATXDRV_UPDATE_PLAYERPOS
      ATXDRV_MvtDone:

NoATXDRV_MAIN_RT_PROC:
ret

;========================================================
ATXDRV_KEYHANDLERPROC:	  ;returns last tick count in esi
;========================================================
invoke GetTickCount
      mov esi,eax
      sub eax,[ATXDRV_AUTOREPTIME]
      cmp eax,[ATXDRV_CURRENT.AutoRepeat]
	  jb ATXDRV_NoKeyCheck
      add [ATXDRV_AUTOREPTIME],eax
      mov edi,[KEY_LIST_ADDR]

      invoke GetAsyncKeyState,[edi+80]
      test eax,80000000h
	   jz nofunccallfwdfast
      or [ATXDRV_Slowdown_BOOL],1
      mov eax,[ATXDRV_CURRENT.IntervalFrontFast]
      sub [IntrCurrStraight],eax
	  ja nofunccallfwdfast
	  mov [IntrCurrStraight],eax
      nofunccallfwdfast:

      invoke GetAsyncKeyState,[edi+88]
      test eax,80000000h
	   jz nofunccallfwdslow
      or [ATXDRV_Slowdown_BOOL],1
      mov eax,[ATXDRV_CURRENT.IntervalFrontSlow]
      sub [IntrCurrStraight],eax
	  ja nofunccallfwdslow
	  mov [IntrCurrStraight],eax
      nofunccallfwdslow:

      invoke GetAsyncKeyState,[edi+96]
      test eax,80000000h
	   jz nofunccallback
      or [ATXDRV_Slowdown_BOOL],1
      mov eax,[ATXDRV_CURRENT.IntervalBack]
      cmp [IntrCurrStraight],MaxStraightTimeInterval_ATXDRV
	  jnb nofastslowdown
	  mov eax,[ATXDRV_CURRENT.IntervalBackFast]
      nofastslowdown:
      add [IntrCurrStraight],eax
      cmp [IntrCurrStraight],MaxStraightTimeInterval_ATXDRV*2
	  jb nofunccallback
	  mov [IntrCurrStraight],MaxStraightTimeInterval_ATXDRV*2
	  sub [IntrCurrStraight],eax
      nofunccallback:

      invoke GetAsyncKeyState,[edi+104]
      test eax,80000000h
	   jz nofunccallleft
      or [ATXDRV_Slowdown_BOOL],2
      mov eax,[ATXDRV_CURRENT.IntervalLeft]
      sub [IntrCurrSide],eax
      cmp [IntrCurrSide],-MaxSideTimeInterval_ATXDRV
	  jg nofunccallleft
	  mov [IntrCurrSide],-MaxSideTimeInterval_ATXDRV
      nofunccallleft:

      invoke GetAsyncKeyState,[edi+112]
      test eax,80000000h
	   jz nofunccallright
      or [ATXDRV_Slowdown_BOOL],2
      mov eax,[ATXDRV_CURRENT.IntervalRight]
      add [IntrCurrSide],eax
      cmp [IntrCurrSide],MaxSideTimeInterval_ATXDRV
	  jl nofunccallright
	  mov [IntrCurrSide],MaxSideTimeInterval_ATXDRV
      nofunccallright:

      test [ATXDRV_Slowdown_BOOL],1
	   jnz NoStraightSlowdown
	   mov eax,[ATXDRV_CURRENT.IntervalSlowdown]
	   cmp [IntrCurrStraight],MaxStraightTimeInterval_ATXDRV
	       jb NoNegStraightSlowdown
	       neg eax
	   NoNegStraightSlowdown:
	   add [IntrCurrStraight],eax
      NoStraightSlowdown:


      test [ATXDRV_Slowdown_BOOL],2
	   jnz NoTurnSlowdown
	   mov eax,[ATXDRV_CURRENT.IntervalTurnstop]
	   cmp [IntrCurrSide],0
	       jb NoNegTurnSlowdown
	       neg eax
	   NoNegTurnSlowdown:
	   add [IntrCurrSide],eax
      NoTurnSlowdown:

      mov [ATXDRV_Slowdown_BOOL],0
ATXDRV_NoKeyCheck:
ret


;========================================================
ATXDRV_SET_SAVE_OBJ_POS_ROT:
;========================================================
	push esi
	push edi
	mov edx,[ATXDRV_CURRENT.Instance]
	mov edi,ATXDRV_INITIALROTPOS
	lea esi,[edx+30h]
	mov ecx,8
	rep movsd

	lea esi,[edx+30h]
	mov edi,ATXDRV_CURRENTROTPOS
	mov ecx,8
	rep movsd
	pop edi
	pop esi
ret

;========================================================
ATXDRV_STRAIGHT_PROC:	;[esp+4] = forward vector
;========================================================
push ebx
	mov ebx,ATXDRV_CURRENTROTPOS
	push 0
	lea ecx,[ebx+0Ch]
	push Temp_Fly_Buffer2
	call CONVERT_TO_FACING_PROC_010

	mov ecx,ebx
	push DWORD [esp+8]			;vector length
	mov edx,ebx
	call FacingToVectorAdd			;eax = facing values

pop ebx
ret 4

;========================================================
ATXDRV_SIDE_PROC:   ;[esp+4] = rotation angle
;========================================================
;This proc is VERY far from optimal, so it does not use matrices for
;rotation or anything deviant from what has been used in ATX so far (quat mul., facing values).
;Remember, I'm not a 3D programmer, so bear with me.
;What it does:
;Rotates the current instance by a certain angle, around a certain point (on the x-y plane ONLY,
;this plane being relative to the object's current facing values and NOT to the fixed world x-y plane).
;Normally, the game rotates objects around their centers (without location
;modification), so the only way I can emulate rotating around a specifiable
;point (with my knowledge) is to use a series of quat rotations and vector additions.
;Note: The new rotation point can only be shifted along the axis defined by the object's
;original facing values, so it is relatively one-dimensional.
;1. Substract the specified offset from the object's position to get the new point of rotation.
;   (with relative X-Y plane). This is done by using the object's initial facing values to
;   create a vector to substract along the object's current facing value (single-axis only).
;   The rotation point offset defines the length of this vector.
;2. Do rotation of object using quat multiplication.
;3. Use the new rotation values to create a vector (with length defined by rotation point offset)
;   to add to the point of rotation (which gives final location). (note: must make sure to negate vector
;   for main function, or it will substract instread of adding).


push ebp
mov ebp,esp
sub esp,16+16
push ebx

	mov ebx,ATXDRV_CURRENTROTPOS

;move object position to point determined by offset
	push Temp_Fly_Buffer3			;(default/no importance here)
	lea ecx,[ebx+0Ch]			;source values (quat)
	push Temp_Fly_Buffer2			;param 1 = dest for values (returned in eax)
	call CONVERT_TO_FACING_PROC_010 	;2 params

	mov ecx,ebx
	push [ATXDRV_CURRENT.RotPosOffset]	;vector length (offset)
	mov edx,ebx
	call FacingToVectorAdd			;eax = facing values

;rotation object around object's relative z axis (not world z axis)
	lea ecx,[ebp+8]
	lea edx,[ebp-16]
	call ToLocalQuat_AxisZ

	lea eax,[ebx+0Ch]		    ;instance quat
	lea ecx,[ebp-16]		    ;local rotation
	lea edx,[ebp-32]		    ;new quat
	call QuaternionMul

	mov eax,[ebp-32]
	mov [ebx+0Ch],eax
	mov eax,[ebp-28]
	mov [ebx+10h],eax
	mov eax,[ebp-24]
	mov [ebx+14h],eax
	mov eax,[ebp-20]
	mov [ebx+18h],eax

;move object position in new facing direction (to finally emulate rotation around new point)
	push 0					;(default/no importance here)
	mov ecx,ATXDRV_CURRENTROTPOS+0Ch	;source values (new quat)
	push Temp_Fly_Buffer2			;param 1 = dest for values (returned in eax)
	call CONVERT_TO_FACING_PROC_010 	;2 params

	mov ecx,ebx
	push [ATXDRV_CURRENT.RotPosOffset]	;vector length (offset)
	mov edx,ebx
	call FacingToVectorSub			;eax = facing values

pop ebx
mov esp,ebp
pop ebp
ret 4

;========================================================
ATXDRV_APPLYPHYSICS:	 ;calculate gravitational force/displacement, current vector
;========================================================
;ebx = instance


ret

;========================================================
ATXDRV_SETNEWROTPOS:	     ;(of target instance)
;========================================================
;ebx = instance
	mov ecx,ebx
	push 0
	mov eax,[ecx]
	push ATXDRV_CURRENTROTPOS
	call DWORD [eax+38h]
ret

;========================================================
ATXDRV_APPLYPUSH:     ;used to tell engine to start physics on object once more (faster)
;========================================================
;ebx = instance

	mov edx,AT10_EMITTER_SIM_OBJECT
	mov eax,[ebx+30h]
	mov [edx+30h],eax
	mov eax,[ebx+34h]
	mov [edx+34h],eax
	fld DWORD [ebx+38h]
	fsub [float_100]
	fstp DWORD [edx+38h]
	mov eax,[ebx+4Ch]
	mov [edx+4Ch],eax

	;emitter facing upward (for quaternion)
	mov DWORD [edx+3Ch],0.70710678118654752440084436210485
	mov DWORD [edx+40h],0.70710678118654752440084436210485
	mov DWORD [edx+44h],0.000000
	mov DWORD [edx+48h],0.000000

;set rotation values to push upward slightly

	mov ecx,AT10_SIM_OBJECT
	mov DWORD [edx+4],0

	mov [ecx+04h],DWORD 0
	mov [ecx+18h],ebx			;Target
	or BYTE [ecx+1Ch],1			;Impulse
	mov DWORD [ecx+38h],0.10000000		;Push
	mov eax,[ecx]
	mov [ecx+3Ch],edx			;Emitter object
	call DWORD [eax+8]			;AT10 MAIN PROC

ret

;========================================================
ATXDRV_UPDATE_PLAYERPOS:     ;if player position not updated, will not follow object
;========================================================
;ebx = instance
;must use new values directly from object

ret



