;compile using FASM (see "SOURCE_README.txt" for last version used)

PATCHER_VERSION 	equ	'2.2'

format PE GUI 4.0
entry START
stack 20000h		;required: GetOpenFileName may crash under certain circumstances if less
			;(witnessed with WinRAR menu options, when right-clicking on an EXE file)

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this
include 'ATX_PATCH_VALUES.inc'

;=================================================================
section '.code' code readable executable
;=================================================================
START:
push ebp
mov ebp,esp
push ebx
       xor ebx,ebx	;ebx = file handle
push edi		;edi = error message pointer
push esi

       mov [OFN_info.lStructSize],sizeof.OPENFILENAME
       mov [OFN_info.lpstrFilter],filter_strings
       mov [OFN_info.lpstrFile],source_file
       mov [OFN_info.nMaxFile],512
       mov [OFN_info.lpstrDefExt],default_extension
       mov [OFN_info.lpstrTitle],open_file_caption
       mov [OFN_info.Flags],OFN_FILEMUSTEXIST+OFN_LONGNAMES+OFN_PATHMUSTEXIST+OFN_EXPLORER+OFN_HIDEREADONLY
invoke GetOpenFileName,OFN_info
       test eax,eax
       mov edi,0
	    jz MAINEXIT

       mov edi,dest_file
       mov esi,source_file
	    copyfilenameloop:
	    mov al,[esi]
	    mov [edi],al
		test al,al
		jz filenameendfound
	    inc edi
	    inc esi
	    jmp copyfilenameloop
       filenameendfound:
       mov DWORD [edi-4],'_ATX'
       mov esi,edi
       mov DWORD [edi],'.exe'
       mov BYTE [edi+5],0
       lea ecx,[edi+4]

       findfilepartatx:
       dec esi
       cmp BYTE [esi],'\'
	   jnz findfilepartatx
       inc esi
       sub ecx,esi
       mov edi,WriteSuccessFileName
       rep movsb

       mov ecx,(EndSuccessEndText-SuccessEndText)/4
       mov esi,SuccessEndText
       rep movsd

invoke CopyFile,source_file,dest_file,FALSE
	test eax,eax
	mov edi,ErrorText1
	    jz MAINEXIT

invoke SetFileAttributes,dest_file,FILE_ATTRIBUTE_NORMAL
	test eax,eax
	mov edi,ErrorText6
	    jz MAINEXIT

invoke CreateFile,dest_file,GENERIC_WRITE,FILE_SHARE_WRITE,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL,0,0
	test eax,eax
	mov edi,ErrorText2
	    jz MAINEXIT
	cmp eax,-1
	    jz MAINEXIT
	mov ebx,eax

invoke GetFileSize,eax
	cmp eax,-1
	mov edi,ErrorText3
	    jz MAINEXIT
	mov [filesize],eax

	cmp eax,_exe_P6_1_1_Size
		jz _exe_P6_1_1
	cmp eax,_exe_P5_1_1_Size
		jz _exe_P5_1_1
	cmp eax,_exe_K6_1_1_Size
		jz _exe_K6_1_1
	cmp eax,_exe_P5_Demo_Size
		jz _exe_P5_Demo
	mov edi,ErrorText5
	jmp MAINEXIT

_exe_P6_1_1:
	mov [BaseData],P6_struc
	jmp DETECT_EXE_SUCCESS
_exe_P5_1_1:
	mov [BaseData],P5_struc
	jmp DETECT_EXE_SUCCESS
_exe_K6_1_1:
	mov [BaseData],K6_struc
	jmp DETECT_EXE_SUCCESS
_exe_P5_Demo:
	mov [BaseData],Demo_Struc
DETECT_EXE_SUCCESS:
mov esi,[BaseData]

WRITE_EXE_CODE [entrypoint],[entry_call],5,ErrorText4
WRITE_EXE_CODE [exit_addr_1],[exit_call],6,ErrorText4
WRITE_EXE_CODE [exit_addr_2],[exit_call],6,ErrorText4
WRITE_EXE_CODE [freespace_addr],[maincode_addr],[maincode_length],ErrorText4

	lea esi,[exe_name]
	mov ecx,10
	mov edi,ExeShowType
	rep movsd

	mov edi,WriteSuccess
invoke CloseHandle,ebx		;success!
	jmp show_msgbox
;=================================================================
MAINEXIT:
	test ebx,ebx
	     jz no_closehandle
invoke CloseHandle,ebx
	no_closehandle:

	test edi,edi
	     jz NoDeleteFile
invoke DeleteFile,dest_file
	NoDeleteFile:

	test edi,edi
	     jz no_msgbox
	show_msgbox:
invoke MessageBox,0,edi,msgbox_caption,0
	no_msgbox:

	pop esi
	pop edi
	pop ebx
	mov esp,ebp
	pop ebp
invoke ExitProcess,0

;=================================================================
section '.data' data readable writeable
;=================================================================

OFN_info		OPENFILENAME

filter_strings	     db      "Executable files",0,"*.exe",0
		     db      "All files",0,"*.*",0,0
default_extension    db      "exe",0
open_file_caption    db      "ATXTres Patcher - select executable to patch",0
msgbox_caption	     db      "ATXTres Patcher",0

source_file	     db      500 dup 0
dest_file	     db      500 dup 0

filesize		dd	0
byteswritten		dd	0

WriteSuccess	db	"Detected executable type:",0Dh,0Ah
   ExeShowType	db	40 dup 0
		db	0Dh,0Ah,"Executable successfully copied and patched as:",0Dh,0Ah
WriteSuccessFileName	db	500 dup 0

SuccessEndText	db	0Dh,0Ah
		db	0Dh,0Ah,"Please read ATX_DOCS\_ATX_README.txt before using."
		db	0Dh,0Ah,"Note: the executable created by this patcher is valid"
		db	0Dh,0Ah,"for all versions. You do not need to run this patcher"
		db	0Dh,0Ah,"if a previous ATXTres release was already installed."
		dd	0
	EndSuccessEndText:
ErrorText1	db	"Could not copy specified file.",0
ErrorText2	db	"New file could not be opened for writing.",0
ErrorText3	db	"Could not get file size.",0
ErrorText4	db	"Could not write to copy of specified file.",0
ErrorText5	db	"Unsupported Trespasser executable. ATXTres requires",0Dh,0Ah
		db	"an executable patched to v1.1 (1.0.117.0) using either",0Dh,0Ah
		db	"of the official patches (large or small), or the demo exe.",0
ErrorText6	db	"Could not set file attributes.",0

;=================================================================
section '.exedata' data readable writeable
;=================================================================
include 'ATX_PATCH_EXE_CODE.inc'

;=================================================================
section '.idata' import data readable writeable
;=================================================================
  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL',\
	  comdlg,'COMDLG32.DLL'


  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CopyFile,"CopyFileA",\
	 CreateFile,"CreateFileA",\
	 DeleteFile,"DeleteFileA",\
	 ExitProcess,"ExitProcess",\
	 GetFileSize,"GetFileSize",\
	 SetFilePointer,'SetFilePointer',\
	 SetFileAttributes,'SetFileAttributesA',\
	 WriteFile,'WriteFile'

  import user,\
	 MessageBox,'MessageBoxA'

  import comdlg,\
	 GetOpenFileName,'GetOpenFileNameA'

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_ICON,icons,\
		  RT_GROUP_ICON,group_icons,\
		  RT_VERSION,versions

	resource icons,\
	   1,LANG_NEUTRAL,icon_data

  resource group_icons,\
	   17,LANG_NEUTRAL,main_icon

	resource versions,\
	   1,LANG_NEUTRAL,version

	icon main_icon,icon_data,'patchericon.ico'

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','ATX Trespasser executable patcher',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',PATCHER_VERSION,\
	  'ProductVersion',PATCHER_VERSION,\
	  'OriginalFilename','ATX_PATCHER.EXE'

